
6th August 2007 ( 32 )

[Fixed] Sometimes not loading resources embedded in maps
[Fixed] BETA tag in server description 
[Fixed] Sliders breaking when being unfrozen
[Fixed] Crash when lua_log 1
[Fixed] Misc crashes when playing Half-Life 2 in multiplayer
[Fixed] Tool tree not being sorted

[Lua] Fixed print not adding \n
[Lua] Added GM:CanPlayerSuicide( ply )



2nd August 2007 ( 28b / 29b / 30b / 31 )

[Add] Finger Poser
[Add] Trails Tool
[Add] Lightbulb Tool
[Add] Camera Tracking. Press USE when looking at an object with the camera.
[Add] Camera Roll. Move the mouse sideways while holding RMB to roll.
[Add] Convar: physgun_rotation_sensitivity (default 0.1)
[Add] lua_redownload - Forces a Lua reconnect for all clients.
[Add] Lua will now condump on critical error
[Add] Tools list now collapsible
[Add] tool_* console commands to activate tools
[Add] PostProcess overlay now shows thumbnails
[Add] 'Sun Size' option to sunbeams
[Add] Notification when kicked due to different scripts
[Add] Lamps can now be toggled on and off
[Add] More materials

[Change] Double pressing reload with the physgun now unfreezes all props
[Change] Single pressing reload with the physgun now unfreezes the prop you're looking at and all entities constrained to it
[Change] Prevented addons from adding [tags] to the game description
[Change] Increased elastic constraint limits
[Change] Forced mouse filtering on (for rotating, camera zooming)
[Change] gamemode_reload, swep_reload and sent_reload no longer need sv_cheats 1 for server admins
[Change] r_DrawDetailProps is no longer a cheat
[Change] Divided options tab into categories

[Fixed] Weapons having no lag compensation
[Fixed] Crash when making wheels with 0 torque then changing their torque
[Fixed] Crash with incorrectly defined context menu comboboxes
[Fixed] Particles sometimes not moving
[Fixed] Possible Freezing due to NaN numbers from Lua
[Fixed] Particle distance alpha not fading properly
[Fixed] lua_run_cl needing quotes
[Fixed] Crash with npc_sniper
[Fixed] Timing errors when making timers in predicted clientside functions
[Fixed] SWEPS misbehaving with pings > 100
[Fixed] Prevented crashing when too many Lua Effects
[Fixed] Prevented crashing when too many Lua Particle Emitters
[Fixed] Trying to show empty tooltips
[Fixed] Jagged camera movement when zoomed all the way in
[Fixed] Ragdoll spazzing when recording demos
[Fixed] Invalid paths getting added to the searchpaths
[Fixed] Rare crash when being kicked from Script Enforce'd servers
[Fixed] Misc VPhysics crashes
[Fixed] Cameras not getting cleaned up
[Fixed] Crash starting d1_town_03 in multiplayer
[Fixed] Crash starting d1_canals_01a in multiplayer
[Fixed] Search path orders getting messed up, resulting in slow load times/missing sounds/switched textures
[Fixed] Menus sometimes not closing when closing the spawnmenu/context menu
[Fixed] Lua File cache sometimes reloading unchanged files
[Lua] Infinite Loop protection
[Lua] ENTITY:SkinCount() (returns int)
[Lua] Added util.PointContents( int )
[Lua] Added GAMEMODE:SetupPlayerVisibility( player )
[Lua] Added AddOriginToPVS( vector )
[Lua] Added Error( text )
[Lua] Fixed pod returning false to IsVehicle()
[Lua] Added LerpAngle( float, angle, angle )
[Lua] Added LerpVector( float, vec, vec )
[Lua] Added PANEL:PaintManual()
[Lua] Added PANEL:SetPaintedManually( bool )
[Lua] Added PANEL:RequestFocus()
[Lua] No longer need to call ParticleEmitter:Finish()
[Lua] Added SWEP:DrawWorldModel()
[Lua] Added ParticleEmitter:SetNearClip( float, float )
[Lua] Added ParticleEmitter:SetParticleCullRadius( float )
[Lua] Added Player:DropNamedWeapon( string )
[Lua] Added Player:DropWeapon( Weapon )
[Lua] Added SWEP:Equip( owner )
[Lua] Added SWEP:OnDrop()
[Lua] Added render.StartMaterialOverride( material )
[Lua] Added Player:GetRagdollEntity()
[Lua] Added Player:RemoveAllAmmo()
[Lua] Added Player:SetAmmo( ammoid, count )
[Lua] Added Player:TraceHullAttack( vecStart, vecEnd, vecMin, vecMax, damage, damagetype, forcescale ) - returns hurt entity
[Lua] Added Player:SetUnDuckSpeed( time )
[Lua] Added Player:SetDuckSpeed( time )
[Lua] Added Player:SetRunSpeed( speed )
[Lua] Added Player:SetWalkSpeed( speed )
[Lua] Added Player:SetCrouchedWalkSpeed( multiplier )
[Lua] FireBullets table now accepts a 'HullSize' int key (if over 0 defines the hull size of the bullet)
[Lua] Added GAMEMODE:GetCrouchTime( Player, bDuckJump, Ducking )
[Lua] Player:TakeDamage moved to Entity:TakeDamage
[Lua] Updated Lua to 5.1.2
[Lua] Added GAMEMODE:CanPlayerEnterVehicle( player, vehicle, role )
[Lua] Added GAMEMODE:PlayerEnteredVehicle( player, vehicle, role )
[Lua] Added global GAMEMODE_NAME
[Lua] Particle:SetLifeTime() now accepts negative values for delayed spawning
[Lua] Added >>, <<, |, & operators
[Lua] Added CSoundPatch:SetSoundLevel( level )
[Lua] Added DynamicLight( _int_ )  returns a dynamiclight object.
[Lua] Added Player:SetDSP( effectid, bQuickreset )
[Lua] Added GAMEMODE:OnDamagedByExplosion( ply, dmginfo )
[Lua] Fixed tracer effects getting a bad startpos
[Lua] GAMEMODE:EntityTakeDamage is now called for players too
[Lua] Added Panel:GetCaretPos()
[Lua] Added Panel:SetCaretPos( int )
[Lua] Added Entity:Visible( ent ) ( returns true if entity can see ent )
[Lua] Added Entity:VisibleVec( vec ) ( returns true if entity can see vec )
[Lua] Added NPC:SetHullType( hulltype )
[Lua] Added NPC:SetHullType()
[Lua] Added NPC:SetHullSizeNormal()
[Lua] Added NPC:CapabilitiesClear()
[Lua] Added NPC:CapabilitiesAdd( int )
[Lua] Added NPC:CapabilitiesRemove( int )
[Lua] Added NPC:CapabilitiesGet()
[Lua] Added NPC:TaskComplete()
[Lua] Added NPC:TaskFail( string )
[Lua] Added NPC:RemoveMemory()
[Lua] Added NPC:ClearSchedule()
[Lua] Added NPC:IsCurrentSchedule( Schedule ) (returns bool)
[Lua] Added PrecacheScene( string )
[Lua] Added NPC:UpdateEnemyMemory( entity, pos )
[Lua] Added NPC:SetExpression( string )
[Lua] Added NPC:ClearExpression()
[Lua] Added NPC:GetExpression() (returns string)
[Lua] Added GetTaskID( string ) (returns int or nil)
[Lua] Added NPC:UpdateEnemyMemory( entity, pos )
[Lua] Added NPC:SetExpression( string )
[Lua] Added NPC:ClearExpression()
[Lua] Added NPC:GetExpression() (returns string)
[Lua] Added NPC:StartEngineTask( id, data )
[Lua] Added NPC:RunEngineTask( id, data )
[Lua] Added NPC:GetNPCState()
[Lua] Added NPC:SetNPCState( state )
[Lua] Added NPC:MaintainActivity()
[Lua] Added Entity:SequenceDuration()
[Lua] Added NPC:ConditionName( int )
[Lua] Added NPC:ClearCondition( int )
[Lua] Added NPC:HasCondition( int )
[Lua] Added NPC:SetCondition( int )
[Lua] Added NPC:Classify()
[Lua] Added NPC:NavSetGoalTarget( ent, vec )
[Lua] Added NPC:NavSetRandomGoal( fMinDist, vecDir )
[Lua] Added NPC:NavSetGoal( vec )
[Lua] Added NPC:NavSetWanderGoal( fMinDist, fMaxDist )
[Lua] Added NPC:GetMovementActivity()
[Lua] Added NPC:SetMovementActivity( ACT_RUN etc )
[Lua] Added NPC:GetMovementSequence()
[Lua] Added NPC:SetMovementSequence( int )
[Lua] Added NPC:GetArrivalActivity()
[Lua] Added NPC:SetArrivalActivity( ACT_RUN etc )
[Lua] Added NPC:GetArrivalSequence()
[Lua] Added NPC:SetArrivalSequence( int )
[Lua] Added NPC:SetArrivalDirection( vec )
[Lua] Added NPC:SetArrivalDistance( flt )
[Lua] Added NPC:SetArrivalSpeed( flt )
[Lua] Added NPC:GetPathDistanceToGoal()
[Lua] Added NPC:GetPathTimeToGoal()
[Lua] Added NPC:ClearGoal()
[Lua] Added NPC:StopMoving()
[Lua] Added NPC:SetMaxRouteRebuildTime( fl )
[Lua] Added NPC:Give( weaponname )
[Lua] Added Entity:SetRenderAngles( ang ) (clientside)
[Lua] Added Entity:GetRenderAngles( ang ) (clientside)
[Lua] Added Entity:SetRenderOrigin( vec ) (clientside)
[Lua] Added Entity:GetRenderOrigin( vec ) (clientside)
[Lua] Added SuppressHostEvents( player )
[Lua] Added UnPredictedCurTime()
[Lua] Added IsFirstTimePredicted()
[Lua] Entity:SetParent( ent, attachmentid )
[Lua] Added Panel:SetContentAlignment( int )
[Lua] Added table.SortByMember( Table, MemberName, bAsc )
[Lua] Added GAMEMODE:AdjustMouseSensitivity()
[Lua] Added SWEP:AdjustMouseSensitivity()
[Lua] Added SWEP:NPCShoot_Primary( ShootPos, ShootDir )
[Lua] Added SWEP:NPCShoot_Secondary( ShootPos, ShootDir )
[Lua] Added SWEP:GetCapabilities()
[Lua] Fixed crash when giving surface.GetTextSize a NULL string
[Lua] Added GAMEMODE:SpawnMenuEnabled()
[Lua] GAMEMODE:GravGunPunt now gets called when punting held objects
[Lua] Added util.SpriteTrail( Entity, iAttachmentID, Color, bAdditive, fStartWidth, fEndWidth, fLifetime, fTextureRes, strTexture )
[Lua] Added scripted AI base
[Lua] Added OrderVectors( v1, v2 ) (makes min/max vectors)
[Lua] Fixed crash when using ents.FindInBox() with invalid box
[Lua] Added PANEL:SetTextInset( int, int )
[Lua] Added PANEL:SetPaintBorderEnabled( b )
[Lua] Added PANEL:SetPaintBackgroundEnabled( b )
[Lua] Added PANEL:CursorPos()
[Lua] Added healthleft, healthtaken to GM:PlayerHurt
[Lua] Fixed attacker being NULL in GM:PlayerHurt
[Lua] Fixed GM:ScalePlayerDamage not being called
[Lua] Added DamageInfo:IsDamageType( int )
[Lua] Added PANEL:MoveToFront()
[Lua] Added PANEL:IsMultiline()
[Lua] Added PANEL:DrawTextEntryText( col, col, col )
[Lua] Added PANEL:FocusNext()
[Lua] Added PANEL:FocusPrevious()
[Lua] Added PANEL:SetFocusTopLevel( bool )
[Lua] Added PANEL:SetTabPosition( int )
[Lua] Added GAMEMODE:PreDrawSkybox() (return true to not draw default skybox)
[Lua] Added GAMEMODE:PostDrawSkybox()
[Lua] Added Entity:DispatchTraceAttack( dmginfo, startpos, endpos )
[Lua] Added Panel:SetTooltip( text )
[Lua] Added CreateMaterial( name, shader, params )


17th May 2007 (27)

[Fixed] Crash when joining a map with func_dust


16th May 2007 (26)

[Add] Ragdoll/NPC Inflator Tool
[Add] New Balloon and Remove particle effects
[Add] On-screen script error notification
[Add] Thruster/Wheels/Buttons now show models in the menu

[Change] Spawnicons now load asynchronously (faster)
[Change] Lamp glow effect

[Fixed] Not being able to open the RT Window
[Fixed] Occasional crash when playing Spacebuild
[Fixed] Added clientside concommand queue to prevent timeouts
[Fixed] Scripted Entities using lots of bandwidth
[Fixed] Entity highlight clipping through close objects
[Fixed] Bug that meant spawnicons would keep getting regenerated
[Fixed] Ropes floating for a second after remove
[Fixed] Crash when npc_combine tries to use secondary fire
[Fixed] Advance Ballsocket tool breaking if switching away half way through
[Fixed] Misc Physics crashes
[Fixed] Server join crash due to badly coded STOOLS

[Lua] Lots of optimizations
[Lua] Added SENT:SetAutomaticFrameAdvance( bool )
[Lua] Added ENT:SetModelScale( vector )
[Lua] Added ENT:GetModelScale() - returns vector
[Lua] Added ENT:SetModelWorldScale( vector )
[Lua] Added ENT:GetModelWorldScale() - returns vector
[Lua] Added ENT:SetupBones()
[Lua] Added Vector:Rotate( angle )
[Lua] Readded missing functions PANEL:GetPos() and PANEL:GetSize()
[Lua] Added Particle:SetAirResistance( float )
[Lua] Added Particle:SetGravity( vector )
[Lua] Added Particle:ShouldCollide( bool )
[Lua] Added Particle:SetBounce( float )
[Lua] Added Particle:SetLighting( bool )
[Lua] Added Particle:SetAngleVelocity( angle )
[Lua] Added Particle:SetCollideCallback( func( Particle, HitPos, Normal ) )
[Lua] Added Particle:SetNextThink( time )
[Lua] Added Particle:SetThinkFunction( func( Particle ) )
[Lua] Added Particle:SetStartLength( float )
[Lua] Added Particle:SetEndLength( float )
[Lua] Added Particle:SetVelocityScale( bool )
[Lua] Added lua/vgui/ which is autorun on client and auto AddCSLuaFile'd on server
[Lua] lua/postprocess/ is now AddCSLuaFile'd on server
[Lua] Added PANEL:PaintOver()
[Lua] Added ENT:LookupBone( name ) (returns bone number)
[Lua] Added ents.GetAll() (returns table, shared)
[Lua] Added GM:PlayerDeathSound()
[Lua] Fixed team.GetScore and team.SetScore

30th April 2007 (25)

[Added] changegamemode <map> <gamemode>
[Added] HTML 'MOTD' box when downloading Lua from server (sv_messageurl to change)
[Added] Ragdolls now visible in duplication process
[Added] Effects now duplicatable

[Changed] Spawnicons are no longer precached
[Changed] CS/DOD etc are no longer used if not installed

[Fixed] VGUI elements sometimes remaining after map change
[Fixed] "Host Error: Bad String" disconnect
[Fixed] Frozen status sometimes not being duplicated
[Fixed] Spawners not cleaning up
[Fixed] NPC Jerkyness
[Fixed] Crash due to bad 3rd party scripts
[Fixed] Not recording non-sandbox demos properly
[Fixed] Crash when fighting againt npc_sniper in multiplayer
[Fixed] Crash when handing yourself a weapon with the physgun
[Fixed] Pump Shotgun not reloading
[Fixed] Occasional freezing when loading bad saved game
[Fixed] Crash when removing a Motor then activating it

[Lua] Added lua_find
[Lua] Added player:GetWeapons (returns table)
[Lua] Added GAMEMODE:StartChat( teammode )
[Lua] Added GAMEMODE:FinishChat()
[Lua] Added GAMEMODE:ChatTextChanged( text )
[Lua] Added Panel:SetModel() (for SpawnIcon control)
[Lua] Added Panel:Refresh() (for HTML control)
[Lua] Added Panel:AddText() (for HTML control)
[Lua] Added Panel:Clear() (for HTML control)
[Lua] Added Panel:Stop() (for HTML control)
[Lua] Added Panel:OpenURL() (for HTML control)
[Lua] Added Panel:SetMultiline() (for TextEntry control)
[Lua] Added Panel:HasFocus()
[Lua] Added surface.SetMaterial
[Lua] Added convars lua_logging_* to enable Lua error logging
[Lua] Lua Console Errors are now coloured (blue server, yellow client)
[Lua] Fixed team module errors
[Lua] Added DropEntityIfHeld( ent ) (forces physcannon/physgun drop)
[Lua] Added GM:CreateEntityRagdoll( ent, ragdoll )
[Lua] Added ENT:WorldToLocalAngles( ang )
[Lua] Added ENT:LocalToWorldAngles( ang )
[Lua] Added ENT:TranslatePhysBoneToBone( int )
[Lua] Added ENT:SetBonePosition( int, vec, ang )


2nd April 2007 (24)

[Added] Duplicator can now store multiple entity groups

[Changed] Merged to Valve's latest code
[Changed] Better feedback on server join (instead of appearing frozen)
[Changed] Duplicator hold pos is now where you right clicked (instead of center)
[Changed] Better caching of downloaded files

[Fixed] Crash when changing level with physics object held
[Fixed] Thruster togglemode
[Fixed] Weapon menu sometimes not populating
[Fixed] Props fading on rubbish video cards

[Lua] Fixed resource.AddFile
[Lua] Added Gamemode hook PreReloadToolsMenu
[Lua] Added Gamemode hook PostReloadToolsMenu



26th March 2007 (23)

[Added] Notification when spawn icons are being generated
[Added] Lua file caching (Loading speedups)
[Added] Right click with no-collide tool will make the object not collide with anything

[Change] Changed how thruster uses keys to make them more usable

[Fixed] Random crashing on some systems
[Fixed] Not being able to chat after typing into the context menu
[Fixed] Not loading some language files
[Fixed] Bug with numpad keys 9 and 3 repeating
[Fixed] Thruster sound being unreliable
[Fixed] Errors when duplicating over your limit
[Fixed] Tooltips not showing on duplicated wheels
[Fixed] Tooltips and 'on' effects not showing on some thrusters
[Fixed] Sometimes timing out when joining servers with 'wiremod'

[Lua] Fixed crashing when adding resource after changelevel
[Lua] Fixed undo's not adding if they only have a function


22nd March 2007 (22)

[Fixed] Occasional hang when loading a saved game
[Fixed] Clientside errors when applying material/color
[Fixed] Hanging after typing insanely high numbers into turret config

[Lua] Added debug.Trace
[Lua] Fixed undo.Function
[Lua] undo.Function can now take an optional args parameter


21st March 2007 (21)

[Added] Options to add shortcuts to desktop
[Added] Option to rebuild all of a categories icons
[Added] Spawn effect
[Added] Can now duplicate NPCs
[Added] Duplicator now copies ragdoll's faceposes too

[Changed] Scoreboard's dimensions
[Changed] Camera's zoom is now clientside
[Changed] Clicking outside of the spawn menu will now close it

[Fixed] Rare client crash when holstering weapon had no owner
[Fixed] Rare client crash when Steam purchase was pending
[Fixed] Over the top scoreboard flashing
[Fixed] Detail model (grass, weeds) not showing on DoD maps
[Fixed] Optimized postprocessing scripts
[Fixed] Spawn menu categories popup menu showing in the top left of the screen
[Fixed] Spawnicons reloading when they didn't have to
[Fixed] Props falling through the world when applying physprops when frozen
[Fixed] Magnets are now included in cleanup
[Fixed] Duplicated props with children leaving children behind when removed
[Fixed] Constant debug output when using nail contraint
[Fixed] Not being able to click buttons on the top left of the screen in some gamemodes/mods
[Fixed] Undo list randomly not showing up
[Fixed] Overflows/Timeouts due to usermessages
[Fixed] Kicking from the scoreboard now works on dedicated servers
[Fixed] Occasional crashes when playing single player maps with maxplayers > 1
[Fixed] Scripted NPcs now look at the player when maxplayers > 1
[Fixed] Camera can now take photos when zooming
[Fixed] Sometimes not being able to type into the spawn menu
[Fixed] Continually spawning props inside each other causing immense cpu usage
[Fixed] NPC Medic battle crash
[Fixed] Crash when empty files in server_settings
[Fixed] Not being able to choose "no sound" for turret
[Fixed] GMDM gibs work as intended
[Fixed] Wheel axis being wonky after duplication
[Fixed] "FindModel NULL name" exit when opening the spawn menu

[Lua] Fixed util.tobool
[Lua] CreateClientConVar and CreateConVar now return a ConVar object
[Lua] Added Toolmode:Allowed()
[Lua] Split clientside and serverside Lua in the budget panel
[Lua] Added con commands dump_hooks and dump_hooks_cl
[Lua] Added clientside con command networkvars_dump
[Lua] Added ScriptEnforcer (http://www.garrysmod.com/wiki/?title=ScriptEnforcer)
[Lua] Added clientside float SWEP:TranslateFOV( float )
[Lua] SWEP:PrimaryFire is now called even if SWEP:SecondaryFire is held down
[Lua] Added Ent:PhysicsFromMesh( table )
[Lua] Added Mesh object
[Lua] Added Matrix object
[Lua] Added cam.PushModelMatrix() and cam.PopModelMatrix()
[Lua] Added PhysObj:IsPenetrating()
[Lua] Added COLLISION_GROUP_WORLD - to make entities only collide with the world
[Lua] Recipient filters can now be stored and reused where applicable
[Lua] Added panel:SetZPos( int )
[Lua] Added clientside chat hook, GM:ChatText( playerindex, playername, text )
[Lua] Added hook.GetTable()
[Lua] Fixed crash when Msg'ing strings containing %s etc
[Lua] Added PANEL:OnCursorMoved( float x, float y )
[Lua] lua_openscript's autocomplete should now be a bit more accurate
[Lua] Added serverside concommand dump_pooledstrings
[Lua] Added undo.AddFunction
[Lua] PANEL:DoClick() now passes x & y
[Lua] Added Panel:ScreenToLocal( x, y )

19th March 2007 (19->20)

[Fixed] Prop Spawner
[Fixed] Remover printing only player's name on remove
[Fixed] Msg outputting duplicate lines
[Fixed] Duplicated frozen physics not adding to physgun reload unfreeze
[Fixed] Bugs when putting hoverball/turret/emitter on a ragdoll
[Fixed] Bone Modifiers not duplicating
[Fixed] Not being being able to choose no sound for turret
[Fixed] Large Usermessages not sending
[Fixed] GetAmmoCount getting strings and numbers mixed up
[Fixed] GMDM gibs work as intended
[Lua] Added undo.AddFunction
[Lua] PANEL:DoClick() now passes x & y
[Lua] Added Panel:ScreenToLocal( x, y )

14th March 2007 (18->19)

[Fixed] Prop spawn effect under DX7 being a big white model
[Fixed] usermessages with custom recipient filter sometimes being ignored
[Fixed] Scoreboard width problems in 800x600
[Fixed] Debug output on NPC spawning and mesh creation
[Fixed] Chat bugs
[Fixed] Crash when joining a game
[Fixed] Duplicator rotation issues


18th January 2007 (16)

[Change] New score board
[Change] Resource adding now works without touching the .res file (Thanks megiddo)
[Change] Tweaked hydraulics/muscle to be less springy
[Change] More download system speedups
[Change] Ragdolls no longer stretch (sv_pedanticragdolls to toggle to the old way)
[Change] Player now presses fire/jump to respawn instead of automatically respawning
[Change] Added option to disable thruster sound

[Fixed] SENTs/SWEPs sometimes appearing as the wrong class with higher pings
[Fixed] VGUI/Lua crashes
[Fixed] SuperDoF effect being 'wrong'
[Fixed] Rare Lua crash
[Fixed] Muscle crash
[Fixed] Fixed being able to 'use' Alyx's Gun
[Fixed] Lua Panels getting nuked when reloading a SWEP/SENT
[Fixed] sv_defaultgamemode sometimes causing problems
[Fixed] Player vs Player damage not working in server creation
[Fixed] Really long pause before joining MP games
[Fixed] Bot names not being completely set on the sever
[Fixed] NPC gunfire effects now show up properly
[Fixed] Player sometimes respawning immediately after being killed

[Lua] Fixed team.GetScore tostring error
[Lua] Added vgui.Register
[Lua] Added Panel:Remove
[Lua] Added Panel:GetWide
[Lua] Added Panel:GetTall
[Lua] Added Panel:GetTable
[Lua] Added Panel:GetParent
[Lua] Added Panel:SetFont
[Lua] Added Panel:SizeToContents
[Lua] Added Panel:SetFGColor
[Lua] Added Panel:SetBGColor
[Lua] Added Panel:InvalidateLayout
[Lua] Added Entity:SetBodygroup( int, int )
[Lua] Added Entity:GetBodygroup( int ) (returns int)
[Lua] Added GetNetworkedAngle/SetNetworkedAngle/SetGlobalAngle/GetGlobalAngle
[Lua] Added umsg:Angle( Angle )
[Lua] Added umsg:Char( char )
[Lua] Added Player:IsMuted()
[Lua] Added Player:SetMuted() 
[Lua] Added Player:IsSpeaking()
[Lua] Added Player:IsVoiceAudible()
[Lua] Player:UserID() is now shared
[Lua] Added Player:EnterVehicle()
[Lua] Entity Tables can now be accessed directly via the entity object (Entity:MyFunction() instead of Entity.GetTable():MyFunction())
[Lua] SENT 'self' object is now the entity itself rather than the table
[Lua] Traces now set HitGroup properly
[Lua] Added DamageInfo:ScaleDamage( float )
[Lua] Added DamageInfo:AddDamage( float )
[Lua] Added DamageInfo:SubtractDamage( float )
[Lua] Added GAMEMODE:ScalePlayerDamage( ply, hitgroup, dmginfo )
[Lua] Added GAMEMODE:ScaleNPCDamage( npc, hitgroup, dmginfo )
[Lua] Fixed GAMEMODE:PhysgunDrop not being called ever
[Lua] Added SQLite module (http://code.google.com/p/gm-sqlite/)
[Lua] Fixed sometimes not calling PlayerDeath
[Lua] Removed limitations on game.ConsoleCommand




8th January 2007

[Added] Weld / Easy-weld nocollide until break checkbox.
[Added] Spawnmenu search

[Change] Duplicate nocollides are ignored.
[Change] Sped up download process
[Change] Deathnotices now use hud_deathnotice_time

[Fixed] Turrets Limit error when adjusting existing turret properties in multiplayer.
[Fixed] Turrets angle not being set when duplicated.
[Fixed] Elastic constraints always being created as "Stretch only"
[Fixed] Dynamite not duplicating properly
[Fixed] Wrong/Missing text for undo, cleanup and limits
[Fixed] Prop spawner spawned props not adding to cleanup
[Fixed] Non existent welds getting stuck in the undo menu
[Fixed] Client crash when easy welding brush based props
[Fixed] Servername spilling out of scoreboard
[Fixed] Manhacks corpses are now clientside
[Fixed] Manhack bleeding
[Fixed] Error when unfreezing statues
[Fixed] Final click with easy weld sometimes not working
[Fixed] Magnetizing props that have been coloured.
[Fixed] Hoverballs not duplicating properly
[Fixed] Reloading with the toolgun calling continuously instead of once when pressed
[Fixed] Some model crashes

[Lua] Output by Start3D2D now listens to the depth buffer
[Lua] Entity:IsConstrained() replaces Entity.IsConstrained
[Lua] player.GetByUniqueID( str )
[Lua] Schedule callbacks are now pcall'd
[Lua] CheckTimers hook being removed
[Lua] Player auth system no longer uses SendLua, players usergroup is stored in a shared variable.
[Lua] Fixed clientside entity table being destroyed when leaving PVS (in multiplayer)
[Lua] Fixed clientside networked vars being destroyed when leaving PVS (in multiplayer)
[Lua] Fixed SENT's being re-initialized when re-entering PVS (in multiplayer)
[Lua] Fixed LastHitGroup not returning anything
[Lua] Fixed :GetClass sometimes cropping the first 3 characters
[Lua] Added resource.AddFile() for adding files to the mapname.res file
[Lua] Added file.FindDir

20th December 2006

[Added] Prop Spawner toolmode.
[Added] Turret toolmode
[Added] Simple duplicator mode, for duplicating single props at a time.
[Added] Pressing reload with any constraint toolmode removes all that type of constraint from the targeted prop (includes nocollide & keepupright)
[Added] Pressing reload with the remover toolmode removes all constraints from the targeted prop
[Added] More useful error messages when client.dll Init() fails

[Change] Clicking an existing balloon now updates its colour & material as well as power.
[Change] Clicking an existing thruster now updates its effect, toggle mode & damage mode, as well as power.
[Change] Clicking an existing dynamite now updates its power.
[Change] Clicking an existing lamp now updates its colour.
[Change] Duplicate welds are now ignored
[Change] Welds automatically nocollide the two welded objects together
[Change] map2 can now only be called by the server admin (doh)
[Change] The undo system is now accurate
[Change] Colour change alpha should now always work, regardless of rendermode
[Change] Improved stability of constrained objects held by the physgun

[Fixed] Undo performance issues
[Fixed] Crash when throwing spear at rollermine
[Fixed] Max balloon limit reached when attempting to change an existing balloons properties
[Fixed] Max emitter limit reached when attempting to change an existing emitters properties
[Fixed] Max hoverball limit reached when attempting to change an existing hoverballs properties
[Fixed] Hoverball strength not getting set
[Fixed] Nailgun nails actually get duplicated properly
[Fixed] Rare physgun crash
[Fixed] PlayerConnect Event crash
[Fixed] Barnacle tongue crash
[Fixed] Rare Control Panel crash (on exit)
[Fixed] Spawn menu save button not saving, and instead deleting all of your spawn menus
[Fixed] Buffer Overrun with 200+ constraints in a constraintsystem
[Fixed] Toolgun prediction getting confused about which stage it's on
[Fixed] Errors when datafolder convar was wrongly defined
[Fixed] Wrong tool information being shown if you change tools half way through an action
[Fixed] Limit errors when duplicating vehicles

[Lua] SWEP:Reload is now called even if the weapon doesn't use clips
[Lua] ENT:GetSkin now works as intended
[Lua] Added GAMEMODE:EntityRemoved( ent )
[Lua] Added ENT:CallOnRemove( name, func, args )
[Lua] Timers are now pcall'd
[Lua] Fixed crashing when panel callback functions errored
[Lua] HUD_PRINTTALK now shows up in single player
[Lua] Added player.GetByUniqueID( uniqueID )

[Lua] When running a script the global SCRIPTNAME contains the script's filename
[Lua] Downloaded autoruns should now autorun
[Lua] Added util.CRC( <string> )


12th December 2006

[Change] Disabled player drowning
[Change] Can now modify the 'strength' of hoverballs
[Change] CS Weapon changes
[Change] Added emitter STOOL

[Fixed] Dedicated Servers not mounting mods/addons
[Fixed] "Joining Server" console spam when joining a server
[Fixed] Antlion Guard crashes
[Fixed] Weapons sometimes appearing not to fire in multiplayer
[Fixed] Lamps not being added to Cleanup
[Fixed] Lamp spawning crash
[Fixed] Vehicles menu not being filled when loading a save
[Fixed] Not being able to change hoverball settings after creation
[Fixed] Max 255 ConVar crash after installing mods
[Fixed] Draworder oddities with dynamite, thrusters etc

[Lua] Fixed Super-DoF swallowing GUIMousePressed and GUIMouseReleased hooks
[Lua] Fixed table.ToString (Andy)
[Lua] Fixed incorrect defines in markup/text_align (Andy)
[Lua] Added PlayerSpawnedNPC hook (Andy)
[Lua] SWEPs can now control their sway and bob
[Lua] SWEP.DrawCrosshair bool now works
[Lua] STOOLs now added to the spawn menu dynamically
[Lua] Fixed concat'd number inaccuracy (thanks Megiddo)
[Lua] Changed the way SENT's render group is handled
[Lua] Added panel:GetValue() (returns string in TextEntry)


04 December 2006

[Change] When entering the name of a new category you can now press enter instead of clicking the OK button
[Change] Added gsg9/arctic models to default CS spawn menu
[Change] Added ironsights to the CS weapons
[Change] Added some more CS weapons
[Change] File download speed ups
[Change] Added Scripted Entity spawning
[Change] Undos now appear on the Undo List
[Change] Added in-game admin panel (n42)
[Change] ai_disable is not longer a cheat
[Change] Added new thruster effects
[Change] Added air resistance option to hoverballs

[Fixed] Crash when removing Antlion Guard
[Fixed] Wrong servername in the scoreboard
[Fixed] Occasionally not being able to join servers
[Fixed] Hoverballs limit being Balloon limit
[Fixed] Wheel limit not applying
[Fixed] Crash with zero length Muscle constraint
[Fixed] Menus staying open after disconnected from server
[Fixed] Dynamites now still work after load (Thanks Snakez)
[Fixed] Stuff not being controllable in a save you didn't create
[Fixed] Physgun beam being invisible if loaded game with physgun out
[Fixed] Duplicated stuff is now cleanupable (n42)

[Lua] Removed 'loadstring' function
[Lua] file.FindInLua and file.Find now ignore files starting with "Copy of"
[Lua] Autorun directories ignore files starting with "Copy of"
[Lua] Fixed SetGlobal*, GetGlobal*
[Lua] player:UniqueID will now always return 1 in SinglePlayer
[Lua] Hook calls are protected to avoid domino effect
[Lua] Numpad calls are protected to avoid domino effect
[Lua] Added SWEP:GetViewModelPosition( pos, angle )
[Lua] Fixed string.ToMinutesSecondsMilliseconds/ToMinutesSeconds (AndyV)


01 December 2006

[Changed] Sliders are less spazzy when attached directly to the world

[Fixed] Addons/Gamemodes not getting mounted on Dedicated Servers
[Fixed] Looping thruster sounds (again :)
[Fixed] Crash when lua_openscript'ing a file without an extension
[Fixed] Duplicate 'name changed' notification
[Fixed] Some people not being able to spawn some props
[Fixed] Airboat fire effects not showing in multiplayer
[Fixed] SWEP menu showing 'admin only' for all weapons
[Fixed] Teams not being labelled properly on the scoreboard
[Fixed] Ghost props not hiding when quick switching from tool gun in multiplayer



30 November 2006

[Fixed] Problems picking up NPC weapons (Selection weirdness, RPG crash)
[Fixed] Missing prop data error when trying to spawn some props
[Fixed] Clientside double physics object bug
[Fixed] Thruster looping sound
[Fixed] Eye Poser
[Fixed] Easy Weld prediction in multiplayer
[Fixed] SENT crash when certain functions failed
[Fixed] Error when button activating a camera
[Fixed] Not being able to specify `no weapon' for NPC spawning
[Fixed] Bugs when spawn menu and context menu opened at exactly the same time
[Fixed] Spawning metrocop causing svc_UpdateStringTable errors in multiplayer

[Change] Increased the thruster power by 10
[Change] Increased the balloon power by 5
[Change] NPC Corpses always fade out in Multiplayer
[Change] NPC Corpses should never become undeletable in Singleplayer (ie you should always be able to interact with them)

29 November 2006

[Fixed] Gibberish text if non-english
[Fixed] Spawn icons not generating/saving


25 November 2006

[Fixed] Server creation window was too wide for 800x600
[Fixed] Physgun crash when object gets destroyed.. when rotating
[Fixed] SWEPs are no longer hidden if they share a weapon selection slot
[Fixed] CS/DoD sounds not loading properly
[Fixed] Addons can now contribute Lua scripts
[Fixed] Crash when trying to create a font over 128 tall (clamped it)
[Fixed] Occasional crash when loading a saved game
[Fixed] Broken Aspect ratio/FOV on saved game screenshots

[Added] Scripted Weapons menu changes/fixes
[Added] Manhack scripted weapon (Singleplayer/Admin only)
[Added] Some CS:S scripted weapons (If you own CS:S)


05 November 2006

[Fixed] crash when console is open for 20+ mins in single player
[Fixed] using stuff when trying to rotate using the physgun
[Fixed] player not having a name when loading a game
[Fixed] noclip either going too fast or too slow
[Fixed] first panel on spawn list now open by default
[Fixed] toolgun shoot effect sometimes not showing in MP
[Fixed] screen flash when other people used the tool gun
[Fixed] limits not applying to duplicator

[Added] Tooltips on buttons/dynamite/etc showing stats and creator
[Added] Thruster plasma effect
[Added] Super DoF mode
[Added] Model browser can now browse dod/cs/hl2/etc model folders individually
[Added] Default DoD spawn menu

